/*
CarbonでちょっぴりC言語！
 
Carbonを使いQuick Drawによる簡単な矩形を表示するサンプルコードです。
メニューとウインドウについては日本語用のnibファイルの設定を行っています。
カーボンではmain.nibファイルの指定でウインドウの表示設定（メタル表示等）や
サイズ指定を行います。変更はインターフェースビルダーで行います。
使用している関数のヘッダーを参照したい場合には、関数名の上にカーソルを
置きダブルクリックすると関連ヘッダーファイルがウインドウに表示されます。
今回の場合ではPaintRect関数はQuickdraw.hのヘッダーが参照されます。
尚、アンチエイリアスやベジエ曲線等はQuickdrawとは別の関数群が存在します。
C言語のでのANSIの標準的なヘッダー表記はありませんがCarbon.hを参照して
おけば使用可能です。

☆このサンプルコードの使用上の注意☆
本プログラムを使用で生じるトラブルや損害等につきましては、利用者が責任を持つ
場合のみ使用可能です。

by lightchaos 2005/04/17
http://www.geocities.jp/virtualon_566/mac/
*/

#include <Carbon/Carbon.h>

void plotrect(void);

int main(int argc, char* argv[])
{
    IBNibRef 		nibRef;
    WindowRef 		window;
    
    OSStatus		err;

	RGBColor  myBkColor = {0,0,0};//R,G,B
	Rect      myRect = {0, 0, 520, 520 };
	
	//-----------------------------------------------------------------------
    err = CreateNibReference(CFSTR("main"), &nibRef);
    require_noerr( err, CantGetNibRef );
    
    err = SetMenuBarFromNib(nibRef, CFSTR("MenuBar"));
    require_noerr( err, CantSetMenuBar );
    
    err = CreateWindowFromNib(nibRef, CFSTR("MainWindow"), &window);
    require_noerr( err, CantCreateWindow );
	
    DisposeNibReference(nibRef);
	SetPortWindowPort( window );
	
	ShowWindow( window );
	RGBBackColor (&myBkColor);
	EraseRect(&myRect);
	
	plotrect();
	
	RunApplicationEventLoop();
	
CantCreateWindow:
CantSetMenuBar:
CantGetNibRef:
		return err;
}

void plotrect(void)
{	
	Rect myRect = {16, 16, 100, 100 };
	//struct Rect {short top;short left;short bottom;short right;};
	RGBColor  myColor1 = {0,0,56000};
	//struct RGBColor {unsigned short red; unsigned short green; unsigned short blue;};
	
	RGBForeColor( &myColor1 );//Quick Draw function RGBForeColor(const RGBColor * color)  
	PaintRect( &myRect );//Quick Draw function  PaintRect(const Rect * r)
	
	RGBColor  myColor2= {50000,0,0};	
	Rect      myRect2 = {16, 116, 100, 200 };
	RGBForeColor( &myColor2 );
	FrameRect( &myRect2 );
	
	RGBForeColor( &myColor1 );
	Rect      myRect3 = {16, 216, 100, 300 };
	PaintRect( &myRect3 );
	MacInvertRect(&myRect3);
	
	Rect      myRect4 = {116, 16, 200,100 };
	RGBColor  myColor4 = {0,0,56000};
	RGBForeColor( &myColor4 );
	PaintOval(&myRect4);

	Rect      myRect5 = {116, 116, 200,200 };
	RGBColor  myColor5 = {50000,0,0};
	RGBForeColor( &myColor5 );
	FrameOval(&myRect5);
	
	RGBForeColor( &myColor1 );
	Rect      myRect6 = {116, 216, 200, 300 };
	PaintOval( &myRect6 );
	InvertOval(&myRect6);	
	
}